
game_start:				; DATA XREF: RAM:4002 o

		ld	hl, MainLoopStepCounter
		ld	de, _PlayerCounter_ 
		ld	bc, SYSVAR_LEN 	;3FFh
		ld	(hl), 0
		call	_LDIR_

		xor	a
		ld	(unk_E005), a

		ld  	a,05fh
		ld 	(r_seed),a 		;init random number

InfinitiGameLooop:
		ei					; CODE XREF: RAM:InfinitiGameLooop j
		jp	InfinitiGameLooop


; ---------------------------------------------------------------------------
initSprFishBall:	
	db	252, 56,SPR_RHair,0 ; DATA XREF: InitActiveSprites+11 o
	db	204,120,SPR_RHair,0
	db	236,184,SPR_RHair,0
	db	204,255,SPR_RHair,0
	db	204,255,SPR_RHair,0
;
R_BridgeSprites:
	db	135,152,SPR_PoolLeft,3
	db	135,168,SPR_PoolRight,3
;
r_FalllingSpr:	
	db	140,208,SPR_RHair,0 ; DATA	XREF: InitActiveSprites:L5B26 o
	db	140,208,SPR_RHair,0
	db	140,208,SPR_RHair,0
;
r_Faces:
	db 167, 224, SPR_Face2
	db 167, 208, SPR_Face2
	db 167, 192, SPR_Face2
	db 167, 176, SPR_Face2

; =============== S U B	R O U T	I N E =======================================


InitActiveSprites:			; CODE XREF: RAM:43FC p	RAM:4417 p ...

; FUNCTION CHUNK AT 5F1B SIZE 00000031 BYTES

		ld	a, 195
		ld	hl, _Sprite_00
		ld	de, _Sprite_00+sprX
		ld	(hl), a
		ld	bc, 127
	
		;ldir
		call	_LDIR_
;
		call	InitSceneAndEnimy
;
		ld	hl, initSprFishBall
		ld	de, _Sprite_11_Fish1
		ld	bc, 20		; 5*4
	
		;ldir
		call	_LDIR_

;
		push	hl
		ld	a, (Xpos_Player_StartPos)
		cp	8
		jp	nz, L5B0F
;
		ld	hl, unk_E1AC
		ld	a, 0FFh
		ld	(hl), a
		inc	hl
		ld	(hl), a

L5B0F:					; CODE XREF: InitActiveSprites+22 j
		pop	hl
		ld	a, (_Level_Enimy_) 	; 0 1 - Ball	Bouncing HIGH
								; 1 2 -	Ball Bouncing
								; 2 4 -	Ball Bouncing small
								; 3 8 -	Kashtan
								; 4 1 -	Fish
								; 5 2 -	Bridge
								; 6 4 -	Bomba
								; 7 8 -	Bee
		and	20h ; ' '
		jp	z, L5B26

		ld	a, (_Flag_Scene_) 	; 0 1	- FishPool
								; 1 2 -	Rope
								; 2 4 -	JumpTubles
								; 3 8 -	4 Fountain
								; 4 1 -	5 Tumb
								; 5 2 -	Vegetables
								; 6 4 -	Fire
								; 7 8 -	Pool Flag
		and	8
		jp	nz, L5B26
;
		ld	de, _Sprite_09_BridgeLeft
		ld	bc, 8
	
		;ldir
		call	_LDIR_


L5B26:					; CODE XREF: InitActiveSprites+32 j
					; InitActiveSprites+39 j
		ld	hl, r_FalllingSpr
		ld	de, _Sprite_16_Falling1
		ld	bc, 12
	
		;ldir
		call	_LDIR_

		ld	de, _Sprite_22_Stone
		ld	hl, r_FalllingSpr
		ld	bc, 4
	
		;ldir
		call	_LDIR_

;
		ld	a, (Xpos_Player_StartPos)
		cp	8
		jp	z, L5B48
		ld	a, 20h ; ' '
		ld	(_Sprite_22_Stone+sprX), a

L5B48:					; CODE XREF: InitActiveSprites+5E j
		ld	a, 4
		ld	hl, r_Faces
		ld	de, _Sprite_27_Life1

L5B50:					; CODE XREF: InitActiveSprites+74 j
		ld	bc, 3
	
		;ldir
		call	_LDIR_

		inc	de
		dec	a
		jp	nz, L5B50
;
		call	DisplayLIFE
;
		ld	a, (_Level_Enimy_)	; 0 1 - Ball	Bouncing HIGH
								; 1 2 -	Ball Bouncing
								; 2 4 -	Ball Bouncing small
								; 3 8 -	Kashtan
								; 4 1 -	Fish
								; 5 2 -	Bridge
								; 6 4 -	Bomba
								; 7 8 -	Bee
		ld	b, a

		ld	hl, L6CE3

		and	2
		jp	nz, L5B72
		ld	a, b
		and	1

		ld	hl, BallJmpTableHigh
		jp	nz, L5B72

		ld	hl, BallJmpTableLow

L5B72:					; CODE XREF: InitActiveSprites+82 j
					; InitActiveSprites+8A j
		ld	(unk_E160), hl
		ld	a, 14
		call	add_a_hl
		ld	(unk_E162), hl
		ld	hl, L63C9
		ld	(unk_E173), hl
		ld	(unk_E169), hl
		ld	(unk_E16B), hl
		ld	(unk_E16D), hl
		jp	L5F1B
; End of function InitActiveSprites



; =============== S U B	R O U T	I N E =======================================

L5F1B:					; CODE XREF: InitActiveSprites+A9 j
		ld	hl, R_Playerspr
		call	init4PlayerSprite
;
		ld	hl, _Sprite_04_Hair+sprAttr
		ld	de, PlayerSprColors
		ld	b, 4

L5F29:					; CODE XREF: InitActiveSprites+44D j
		ld	a, (de)
		ld	(hl), a
		inc	de
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		
		;djnz
		dec b
		jp nz,L5F29

;
		ld	hl, PlayerYPos
		ld	(hl), 108
		inc	hl
		ld	a, (Xpos_Player_StartPos)
		ld	(hl), a
		cp	8
		ld	a, 8
		jp	z, L5F43
		rrca

L5F43:					; CODE XREF: InitActiveSprites+45D j
		inc	hl
		ld	(hl), 0
		ld	(_PlayerFlag_),	a ; 0 1
					; 1 2
					; 2 4 -	1 KeyLeftLeft
					; 3 8 -	1 KeyRight
					; 4 1
					; 5 2
					; 6 4
					; 7 8
		jp	UpdatePlayerSprites
; END OF FUNCTION CHUNK	FOR InitActiveSprites
; ---------------------------------------------------------------------------
PlayerSprColors:db    8, 0Bh, 0Dh,   4	; DATA XREF: InitActiveSprites+441 o

; =============== S U B	R O U T	I N E =======================================


init4PlayerSprite:			; CODE XREF: InitActiveSprites+43B p
					; RAM:68B1 p
		ld	de, _Sprite_00
		ld	bc, 404h

L5F56:					; CODE XREF: init4PlayerSprite+E j
		push	hl
		push	bc
		ld	b, 0
	
		;ldir
		call	_LDIR_

		pop	bc
		pop	hl
		
		;djnz
		dec b
		jp nz,L5F56

		ret
; End of function init4PlayerSprite

; ---------------------------------------------------------------------------
R_Playerspr:	db	144,0,SPR_RHair,0 ; DATA XREF: InitActiveSprites:L5F1B o





; ---------------------------------------------------------------------------
		db 0FEh	; þ
BallJmpTableHigh:
		db    6, 5,	5, 5, 4, 4, 3, 3, 3, 3,	2, 2, 2, 1,	0, 0,0FFh,0FEh
BallJmpTableLow:		
		db    0, 0,	0, 1, 0, 0,	0, 1, 0, 0,	0, 1, 0, 0,	0, 0,0FFh,0FEh

L63C9:	
		db    0,   8,	8,   8	; DATA XREF: InitActiveSprites+9A o
					; RAM:682A o
		db    8,   8,	8,   7
		db    7,   5,	5,   4
		db    4,   3,	3,   2
		db    1,   1,	1,   1
		db    1,   1,	1,   1
		db    0,   0,0FFh

; =============== S U B	R O U T	I N E =======================================



; =============== S U B	R O U T	I N E =======================================


UpdateLifeSprite:			; CODE XREF: RAM:4360 p
					; CheckTimeNearEnd+B p ...
		ld	b, 4
		ld	hl, _Sprite_27_Life1+sprsprID

L669E:					; CODE XREF: UpdateLifeSprite+A j
		ld	(hl), a
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		
		;djnz
		dec b
		jp nz,L669E
;ESL_KORVET
		call process_sprite_faces
;ESL_KORVET


		ret
; End of function UpdateLifeSprite

; =============== S U B	R O U T	I N E =======================================


UpdatePlayerSprites:			; CODE XREF: InitActiveSprites+466 j
					; RAM:L69B0 j ...
		ld	a, (_PlayerFlag_) ; 0 1
								; 1 2
								; 2 4 -	1 KeyLeftLeft
								; 3 8 -	1 KeyRight
								; 4 1
								; 5 2
								; 6 4
								; 7 8
		cp	4
		jp	nz, NoReversePlayer
;
		ld	hl, PlayerAnimationStep
		ld	a, (hl)
		add	a, 7
		ld	(hl), a

NoReversePlayer:			; CODE XREF: UpdatePlayerSprites+5 j
		ld	hl, PlayerYPos
		ld	b, (hl)		; Y
		inc	hl
		ld	c, (hl)		; X
		inc	hl
		ld	a, (hl)		; AnimationStep
		push	af
		ld	hl, _Sprite_04_Hair
;
;esl
;		bit	0, a
		ld 	d,a
		and 1<<0
		ld 	a,d
;esl

		jp	z, L6B2B
	
		inc	b		; Up sprite on each even animation step

L6B2B:					; CODE XREF: UpdatePlayerSprites+1C j
		ld	de, PlayerAnimationTable
		add	a, a
		add	a, a
		call	add_a_de
;
		call	Set2SpriteParam_HL_BC_DE ; YX=BC,SPR_DI=*DE
;
		ld	a, 10h
		add	a, b
		ld	b, a
;
		pop	af
		cp	5
		jp	nz, L6B43
;
		inc	c
		inc	c
		inc	c
		inc	c		; x+=4

L6B43:					; CODE XREF: UpdatePlayerSprites+31 j
		cp	12
		jp	nz, L6B4B
		dec	c
		dec	c
		dec	c
		dec	c		; x-=4

L6B4B:					; CODE XREF: UpdatePlayerSprites+39 j
		call	Set2SpriteParam_HL_BC_DE ; YX=BC,SPR_DI=*DE
;
		ld	a, (WalkMode)

		cp	wm_dead_in_pool ;0Fh
		ret	nc
;
		cp	wm_jump ;1
		jp	z, HideShadow

		cp	wm_endofstage_jumping ;7
		jp	z, SetShadowY140

		cp	wm_jumping_tumb ;3
		ld	a, 140
		jp	c, SetShadowYX_AC
;
		ld	a, 16
		add	a, b

SetShadowYX_AC:				; CODE XREF: UpdatePlayerSprites+54 j
					; UpdatePlayerSprites+6F j
		ld	hl, _Sprite_08_Shadow
		ld	(hl), a		; Y
		inc	hl
		ld	(hl), c		; X
		inc	hl
		ld	(hl), SPR_Shadow
		inc	hl
		ld	(hl), 1		; Color
		cp	72
		ret	nc

HideShadow:				; CODE XREF: UpdatePlayerSprites+4A j
		xor	a
		ld	(_Sprite_08_Shadow+sprAttr), a
		ret
; ---------------------------------------------------------------------------

SetShadowY140:				; CODE XREF: UpdatePlayerSprites+4E j
		ld	a, 140
		jp	SetShadowYX_AC
; End of function UpdatePlayerSprites


; =============== S U B	R O U T	I N E =======================================

; YX=BC,SPR_DI=*DE

Set2SpriteParam_HL_BC_DE:		; CODE XREF: UpdatePlayerSprites+27 p
					; UpdatePlayerSprites:L6B4B p ...
		call	Set1SpriteParam_HL_BC_DE	;YX=BC,SPR_DI=*DE

Set1SpriteParam_HL_BC_DE:		; CODE XREF: DeadSprites+3D p
		ld	(hl), b		; Y
		inc	hl
		ld	(hl), c		; X
		inc	hl
		ld	a, (de)
		inc	de
		ld	(hl), a		; SPR_ID
		inc	hl
		inc	hl
		ret
; End of function Set2SpriteParam_HL_BC_DE

; ---------------------------------------------------------------------------
;
PlayerAnimationTable:
		db SPR_RHair,SPR_RFace1,SPR_RBody1,SPR_RFoot1
		db SPR_RHair,SPR_RFace1,SPR_RBody2,SPR_RFoot2
		db SPR_RHair,SPR_RFace1,SPR_RBody3,SPR_RFoot3
		db SPR_RHair,SPR_RFace1,SPR_RBody3,SPR_RFoot3
		db SPR_RHair,SPR_RFace2,SPR_RBody5,SPR_RFoot5
		db SPR_RHair,SPR_RFace2,SPR_RBody6,SPR_RFoot6
		db SPR_RHair,SPR_RFace1,SPR_RBody4,SPR_RFoot4
;
		db SPR_LHair,SPR_LFace1,SPR_LBody1,SPR_LFoot1
		db SPR_LHair,SPR_LFace1,SPR_LBody2,SPR_LFoot2
		db SPR_LHair,SPR_LFace1,SPR_LBody3,SPR_LFoot3
		db SPR_LHair,SPR_LFace1,SPR_LBody3,SPR_LFoot3
		db SPR_LHair,SPR_LFace2,SPR_LBody5,SPR_LFoot5
		db SPR_LHair,SPR_LFace2,SPR_LBody6,SPR_LFoot6
		db SPR_LHair,SPR_LFace1,SPR_LBody4,SPR_LFoot4

; =============== S U B	R O U T	I N E =======================================


DeadSprites:				; CODE XREF: _do_player_move+325 p RAM:L69F1 p
		ld	hl, PlayerYPos
		ld	a, (hl)		; Y
		add	a, 16
		ld	b, a
		inc	hl
		ld	a, (hl)		; X
		sub	16
		ld	c, a
		inc	hl		; AnimationPhase
;
		ld	a, (_PlayerFlag_) ; 0 1
					; 1 2
					; 2 4 -	1 KeyLeftLeft
					; 3 8 -	1 KeyRight
					; 4 1
					; 5 2
					; 6 4
					; 7 8
		cp	4
		ld	a, (hl)
		jp	nz, L6BE0
;
		dec	hl
		ld	a, (hl)
		add	a, 10h
		ld	c, a
		inc	hl
		ld	a, (hl)
		add	a, 2

L6BE0:					; CODE XREF: DeadSprites+13 j
		ld	de, DeadPlayerSprites
		ld	l, a
		add	a, a
		add	a, a
		add	a, l
		and	0Fh
		call	add_a_de
;
		ld	hl, _Sprite_04_Hair
		call	Set2SpriteParam_HL_BC_DE ; YX=BC,SPR_DI=*DE
		push	bc
		ld	a, (PlayerXPos)
		ld	c, a
		call	Set2SpriteParam_HL_BC_DE ; YX=BC,SPR_DI=*DE
		pop	bc
		ld	a, b
		add	a, 10h
		ld	b, a
		call	Set1SpriteParam_HL_BC_DE ; Y
		dec	hl
		ld	(hl), 8
		ret
; End of function DeadSprites

; ---------------------------------------------------------------------------
DeadPlayerSprites:
		db SPR_RDHair1,SPR_RDFace1,SPR_RDBody1,SPR_RDFoot1,SPR_RDHair2; 0
		db SPR_RDHair1,SPR_RDFace1,SPR_RDBody2,SPR_RDFoot2,SPR_RDHair2;	5
		db SPR_LDHair1,SPR_LDFace1,SPR_LDBody1,SPR_LDFoot1,SPR_LDHair2;	10
		db SPR_LDHair1,SPR_LDFace1,SPR_LDBody2,SPR_LDFoot2,SPR_LDHair2;	15

; =============== S U B	R O U T	I N E =======================================


L6C1A:					; CODE XREF: _do_player_move+61 p	RAM:L6832 p ...
		xor	a
		jp	L6C1F
; ---------------------------------------------------------------------------

L6C1D:					; CODE XREF: RAM:685F p	RAM:68C7 p ...
		ld	a, 1

L6C1F:					; CODE XREF: L6C1A+1 j
		ld	(unk_E200), hl
		ld	(byte_E202), a
		xor	a
		ld	(unk_E205), a
		ret
; End of function L6C1A

; ---------------------------------------------------------------------------
; START	OF FUNCTION CHUNK FOR L6C3C

L6C2A:					; CODE XREF: L6C3C+15 j
		ld	hl, RopeRigthXY
		call	CheckEndRope	; C-miss, NC- near end
		jp	nc, _AtRopeEnd

		ld	hl, RopeLeftXY
		call	CheckEndRope	; C-miss, NC- near end
		jp	nc, _AtRopeEnd

		jp	L6C67
; END OF FUNCTION CHUNK	FOR L6C3C

; =============== S U B	R O U T	I N E =======================================


L6C3C:					; CODE XREF: _do_player_move:_wm01_jump p RAM:_wm03_jumping_tumb p ...

		ld	a, (unk_E144)
		or	a
		jp	nz, L6C67
		
		ld	hl, RopeLeftXY
		ld	a, (unk_E13C)
;esl
;		bit	1, a
		ld 	c,a
		and 1<<1
		ld 	a,c
;esl
		jp	nz, L6C53
		ld	hl, RopeRigthXY
;esl
;		bit	0, a
		and 1<<0
;esl
		jp	z, L6C2A

L6C53:					; CODE XREF: L6C3C+E j
		call	CheckEndRope	; C-miss, NC- near end
		jp	c, L6C67

_AtRopeEnd:				; CODE XREF: L6C3C-C j L6C3C-4 j
		ld	a, l
		and	3
		ld	(unk_E13C), a
		ld	c, a
		call	doBonus		; C - item num

		ld	a, wm_on_rope ;2
		ld	(WalkMode), a

L6C67:					; CODE XREF: L6C3C-2 j L6C3C+4 j ...
		ld	hl, FishPoolCoordsX
		ld	b, 7
		ld	c, 9
		call	CheckBonuses_HL_Table
		ld	a, (byte_E202)
		ld	b, a
		ld	hl, unk_E205
;esl
;		bit	0, b
		and 1<<0
;esl
		jp	nz, L6C7F
		inc	(hl)
		jp	L6C80
; ---------------------------------------------------------------------------

L6C7F:					; CODE XREF: L6C3C+3E j
		dec	(hl)

L6C80:					; CODE XREF: L6C3C+41 j
		ld	a, (hl)
		cp	8
		ld	a, 6
		jp	c, L6C89
		ld	a, 4

L6C89:					; CODE XREF: L6C3C+49 j
		ld	(PlayerAnimationStep), a

;		ld	hl, PlayerYPos
;		ld	de, (unk_E200)

		ld	de, PlayerYPos
		ld	hl, (unk_E200)
		ex 	de,hl
;esl
;		bit	0, b
		ld a,b
		and 1<<0
;esl
		ld	a, (de)
		jp	nz, L6C9A
;esl		
;		neg
		cpl
		add a,1
;esl		

L6C9A:					; CODE XREF: L6C3C+5A j
		add	a, (hl)
		ld	(hl), a
		inc	hl

		ld	a, (_LeftRightKey_Bits)
		or	a
		jp	z, L6CBE

		ld	c, a
		ld	a, (unk_E144)
		inc	a
		jp	nz, L6CB6

;esl
;		bit	3, c
		ld 	a,c
		and 1<<3
;esl
		jp	z, L6CB2

		inc	(hl)
		inc	(hl)
		jp	L6CBE
; ---------------------------------------------------------------------------

L6CB2:					; CODE XREF: L6C3C+70 j
		dec	(hl)
		dec	(hl)
		jp	L6CBE
; ---------------------------------------------------------------------------

L6CB6:					; CODE XREF: L6C3C+6C j
;esl
;		bit	3, c
		ld a,c
		and 1<<3
;esl
		jp	z, L6CBD
		inc	(hl)
		jp	L6CBE
; ---------------------------------------------------------------------------

L6CBD:					; CODE XREF: L6C3C+7C j
		dec	(hl)

L6CBE:					; CODE XREF: L6C3C+65 j	L6C3C+74 j ...
		ex	de, hl
;esl
;		bit	0, b
		ld a,b
		and 1<<0
;esl
		jp	nz, L6CC6
		inc	hl
		jp	L6CC7
; ---------------------------------------------------------------------------

L6CC6:					; CODE XREF: L6C3C+85 j
		dec	hl

L6CC7:					; CODE XREF: L6C3C+88 j
		ld	a, (hl)
		ld	b, a
		inc	a
		jp	nz, L6CDC
		dec	hl
		dec	hl
		push	hl
		ld	hl, unk_E144
		inc	(hl)
		pop	hl
		inc	a
		ld	(byte_E202), a

L6CD8:					; CODE XREF: L6C3C+A1 j	L6C3C+A4 j
		ld	(unk_E200), hl
		ret
; ---------------------------------------------------------------------------

L6CDC:					; CODE XREF: L6C3C+8E j
		inc	a
		jp	nz, L6CD8
		inc	hl
		jp	L6CD8
; End of function L6C3C

; ---------------------------------------------------------------------------
		db 0FEh	; þ
L6CE3:
		db 		2, 1, 2, 1, 2, 1, 1, 1, 1, 1

L6CED:		db 1			; DATA XREF: RAM:6D4D o
		db    1
		db    0
		db    1
		db    0
L6CF2:		db 0			; DATA XREF: RAM:6D32 o
		db 0FFh
		db 0FEh	; þ
L6CF5:		db    4,   4,	3,   3,	  3,   3,   2,	 2 ; DATA XREF:	_do_player_move+5E o
					; RAM:L682F o ...
		db    2,   2,	1,   1,	  1,   1,   0,	 0
		db 0FFh
; ---------------------------------------------------------------------------

_wm02_on_rope:					; DATA XREF: _do_player_move+20 o
		ld	hl, RopeLeftXY
		ld	a, (unk_E13C)
;esl
;		bit	1, a
		and 1<<1
;esl
		jp	z, L6D13
		ld	hl, RopeRigthXY

L6D13:					; CODE XREF: RAM:6D0E j
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		ld	hl, PlayerYPos
		ld	(hl), b
		inc	hl
		ld	a, (_PlayerFlag_) ; 0 1
					; 1 2
					; 2 4 -	1 KeyLeftLeft
					; 3 8 -	1 KeyRight
					; 4 1
					; 5 2
					; 6 4
					; 7 8
		cp	4
		ld	a, c
		jp	nz, L6D26
		add	a, 0Eh
		ld	c, a

L6D26:					; CODE XREF: RAM:6D21 j
		ld	(hl), a
		inc	hl
		ld	(hl), 5
		ld	a, (KeyCurrent)	; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
		ld	b, a
;esl
;		bit	1, a
		and 1<<1
		ld 	a,b
;esl
		jp	z, L6D43

		ld	hl, L6CF2
		call	L6C1D

		ld	a, wm_jump ;1
		ld	(WalkMode), a
		ld	(unk_E144), a

noJMP:					; CODE XREF: RAM:6D4B j	RAM:L6D70 j
		jp	PreparePlayerPosition
; ---------------------------------------------------------------------------

L6D43:					; CODE XREF: RAM:6D30 j
		and	0Ch
		ld	(_LeftRightKey_Bits), a
		call	CheckJump	; cf - jumpKey?
		jp	nc, noJMP

		ld	hl, L6CED
		call	L6C1A

		ld	a, 1
		ld	(WalkMode), a

		ld	a, mJump
		call	SelectMUSIC_A

		ld	a, 0FFh
		ld	(unk_E144), a

		ld	a, (_PlayerFlag_) ; 0 1
								; 1 2
								; 2 4 -	1 KeyLeftLeft
								; 3 8 -	1 KeyRight
								; 4 1
								; 5 2
								; 6 4
								; 7 8
		cp	4
		jp	nz, L6D70

		ld	hl, PlayerAnimationStep
		ld	a, (hl)
		add	a, 6
		ld	(hl), a

L6D70:					; CODE XREF: RAM:6D67 j
		jp	noJMP

