
; =============== S U B	R O U T	I N E =======================================


InitPlayerData_ExPhase:			; CODE XREF: RAM:ML_17_ p RAM:4411 p ...
		ld	a, (RopePhase1)
		ld	b, a
		ld	a, (RopePhase2)
		ld	c, a
		ld	a, (FuntainPhase3)
		ld	d, a
		ld	a, (FuntainPhase4)
		ld	e, a
		push	bc
		push	de
		ld	hl, unk_E130
		ld	de, RopePhase1
		ld	(hl), 0
		ld	bc, last_var-unk_E130-1 ;200h-122h
	
		;ldir
		call	_LDIR_

		pop	de
		pop	bc
		ld	a, b
		ld	(RopePhase1), a
		ld	a, c
		ld	(RopePhase2), a
		ld	a, d
		ld	(FuntainPhase3), a
		ld	a, e
		ld	(FuntainPhase4), a
		ld	a, 12
		ld	(FishPhase+1), a
		ld	a, 24
		ld	(FishPhase+2), a
		ld	a, 1
		ld	(unk_E17E), a
		ld	a, 5
		ld	(unk_E17C), a
		ld	a, 6Ch ; 'l'
		ld	(unk_E13A), a
		ret
; End of function InitPlayerData_ExPhase


; =============== S U B	R O U T	I N E =======================================


DispalyMessages:			; CODE XREF: ML_9_BeforeStage+13 p	RAM:L4414 p ...
		ld	hl, xGameMessages
		call	xStringToVram_HL
;
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
;esl
;		bit	5, a
		and 	1<<5
;esl
		jp	z, L46CF

		ld	hl, x2P
		call	xStringToVram_HL
;
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
		xor	80h ; '€'
		call	putScore
;

L46CF:					; CODE XREF: DispalyMessages+B j
		call	putStage
		call	putTIME
		call	putScene
;
		ld	hl, xConamy1984_2
;ESL_KORVET
;		ld	de,  VLINE+(23*32)+2
		ld	de,  VLINE+(23*32)+2-1
;ESL_KORVET
		call	xStringToVram_HLDE

UpdateHiScore:				; CODE XREF: AddBonus_DE+31 j
					; AddBonus_DE+6F j
		ld	hl, g_HIScore
		ld	de,  VLINE+(0*32)+15
		call	digit6ToScreen

L46EA:					; CODE XREF: AddBonus_DE+5C j
					; AddBonus_DE+65 j
		ld	a, (g_Flags)	; 0 1
							; 1 2
							; 2 4
							; 3 8
							; 4 1 -	0 - joy, 1 - KeyboardUserInput
							; 5 2 -	0 one player,1 - 2 player
							; 6 4 -	Game Flag (no demo)?
							; 7 8 -	Activ Player?


putScore:				; CODE XREF: DispalyMessages+18 p
		ld	de,  VLINE+(0*32)+5
		ld	hl, g_Score_1P	; BCD
		add	a, a
		jp	nc, digit6ToScreen
		ld	e, 25h ; '%'
		ld	hl, g_Score_2P	; BCD

digit6ToScreen:				; CODE XREF: DispalyMessages+33 p
					; putScore+7 j
		ld	b, 3
		jp	DigitToScreen
; End of function digit6ToScreen


; =============== S U B	R O U T	I N E =======================================

DisplayLIFE:
					; CODE XREF: AddBonus_DE+4A p
					; InitActiveSprites+76 p
		ld		a, (MainLoopStepCounter)
		cp		9
		ret		z
;
		ld		hl, _Sprite_27_Life1+sprAttr
		ld		(word_E186), hl
		ld		de,  VLINE+(21*32)+28
;
		ld		a, (_Player1Data_LIFE)
		ld		c, a
		ld		b, 4

L4766:					; CODE XREF: DisplayLIFE+37 j
		push	de
		ld		hl, chrFACES
		dec		c
		jp		p, L4771
		ld		hl, chrnoFaces

L4771:					; CODE XREF: DisplayLIFE+1A j
		push	bc
		ld		bc, 202h
		call	CopyToVRAM_ROW
;
		ld		b, (hl)
		ld		hl, (word_E186)
		ld		(hl), b
		inc		hl
		inc		hl
		inc		hl
		inc		hl
		ld		(word_E186), hl
		pop		bc
		pop		de
		dec		de
		dec		de
		
		;djnz
		dec 	b
		jp 		nz,L4766

;ESL_KORVET
		call process_sprite_faces
;ESL_KORVET


		ret
; End of function DisplayLIFE

; ---------------------------------------------------------------------------
chrnoFaces:	
		db    0,   0		; DATA XREF: DisplayLIFE+1D o
		db    0,   0
		db 	  0
chrFACES:	
		db  15h, 17h		; DATA XREF: DisplayLIFE+16 o
		db  16h, 18h
		db  6


; =============== S U B	R O U T	I N E =======================================


putScene:				; CODE XREF: RAM:43FF p
					; DispalyMessages+21 p
		ld		de,  VLINE+(23*32)+28
		ld		hl, scrScene
		jp		Digit2ToScreen


; =============== S U B	R O U T	I N E =======================================


putStage:				; CODE XREF: DispalyMessages:L46CF p
		ld		de,  VLINE+(0*32)+28
		ld		hl, gStage

Digit2ToScreen:				; CODE XREF: putScene+6 j
		ld		b, 1

DigitToScreen:				; CODE XREF: digit6ToScreen+2 j
					; putStage+22 j
		ld		a, (hl)
		push	af
		and		0Fh
		or		30h ; '0'
		ld		c, a
;
		pop		af
		and		0F0h ; 'ð'
		rra
		rra
		rra
		rra
		or		30h ; '0'
;
		call	vdp_wr_de_a
		inc		de
		ld		a, c
		call	vdp_wr_de_a
		dec		hl
		inc		de
		
		;djnz
		dec 	b
		jp 		nz,DigitToScreen

		ret
; End of function putStage

; =============== S U B	R O U T	I N E =======================================


ShowPlayerID:				; CODE XREF: RAM:4133 p
;esl
;		ld	bc, (g_Flags)	; 0 1
;					; 1 2
;					; 2 4
;					; 3 8
;					; 4 1 -	0 - joy, 1 - KeyboardUserInput
;					; 5 2 -	0 one player,1 - 2 player
;					; 6 4 -	Game Flag (no demo)?
;					; 7 8 -	Activ Player?
;		ld	a, b


		ld	hl, (g_Flags)	; 0 1
							; 1 2
							; 2 4
							; 3 8
							; 4 1 -	0 - joy, 1 - KeyboardUserInput
							; 5 2 -	0 one player,1 - 2 player
							; 6 4 -	Game Flag (no demo)?
							; 7 8 -	Activ Player?
		ld		a, h
		ld  	c, l

		and		1Fh
		ret		nz
;
		ld		de,  VLINE+(0*32)+2
		ld		hl, x1P
;esl
;		bit		7, c
		ld		a,c
		and 		1<<7
;esl


		jp		z, L4743
		ld		hl, x2P
		ld		e, 22h ; '"'

L4743:					; CODE XREF: ShowPlayerID+10 j
		call	vdp_rd_de
		or		a
		jp		z, xStringToVram_HL
		xor		a
		ld		bc, 3
		jp		Fill_VRAM_DE_A_BC
; End of function ShowPlayerID


; =============== S U B	R O U T	I N E =======================================


ClearFromCenter:			; CODE XREF: ML_1_PrepareKonami+6 p
					; ML_6_DemoStartClearScreenPrepareLevel+5 p ...

		ld 	a,M_SCR2_NOP
        	ld      (scr2_pnt_mode),a

		ld	d, HIGH VLINE 	;38h ; '8'
		ld	hl, _ml_delay
		ld	b, 18h
;esl
;		bit	6, (hl)
		ld 	a,(hl)
		and 	1<<6
;esl
		jp	nz, L45AF

		ld	a, 31 		;1Fh
		sub	(hl)
		ld	e, a
;esl
;		set	6, (hl)		; Jump to left/right ...
		ld 	a,(hl)
		or 	1<<6
		ld 	(hl),a
;esl



		jp	L45B4
; ---------------------------------------------------------------------------

L45AF:					; CODE XREF: ClearFromCenter+9 j
;esl
;		res	6, (hl)
		ld 	a,(hl)
		and 	(1<<6)^0xff
		ld 	(hl),a
;;esl
		dec	(hl)
		ret	m
		ld	e, (hl)

L45B4:					; CODE XREF: ClearFromCenter+11 j
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
		and	40h ; '@'
		jp	z, L45C1
;
		ld	a, 40h ; '@'
		add	a, e
		ld	e, a
;
		ld	b, 19+2		; Clear	19 Lines
;

L45C1:					; CODE XREF: ClearFromCenter+1D j
					; ClearFromCenter+2E j
		xor	a
;		call	vdp_wr_de_a
		ld 	(de),a
		call 	x_chr_clear

		ld	a, 32
		call	add_a_de
		
		;djnz
		dec b
		jp nz,L45C1

;
;		ld	de, VRAM_SpriteAttribute
;		ld	a, 208		; 208 -	disable	sprite
;		call	vdp_wr_de_a

;ESL_KORVET
		;call 	process_sprite_erase
		call 	sprite_turn_off
;ESL_KORVET



;
		ld	a, (byte_E00F)
		or	a
		jp	nz, L45E0
;
		;ld	hl, xClear2122_16
		;call	xStringToVram_HL

		;ld 	a,M_SCR2_ALL
        	;ld      (scr2_pnt_mode),a
L45E0:					; CODE XREF: ClearFromCenter+3C j
		xor	a
		ret
; End of function ClearFromCenter

; ---------------------------------------------------------------------------
xClear2122_16:	
		dw 		VLINE+(21*32)+22		; DATA XREF: ClearFromCenter+3E o
		db    	0,   0,	0,   0,	  0,   0,   0,	 0,0FEh
		dw 		VLINE+(22*32)+22
		db    	0,   0,	0,   0,	  0,   0,   0,	 0,0FFh


; =============== S U B	R O U T	I N E =======================================


ShowGameOverPlayer:			; CODE XREF: ML_9_BeforeStage+1D p	RAM:4307 p
		call	xStringToVram_HL
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
		rlca
		and	1
		add	a, '1'
		ld	de,  VLINE+(9*32)+19
		call	vdp_wr_de_a
		ret
; End of function ShowGameOverPlayer

; =============== S U B	R O U T	I N E =======================================


_set_active_player:				; CODE XREF: RAM:4324 p	RAM:43A1 p
		ld	hl, _PlayerCounter_ ; 0	1
					; 1 2
					; 2 4
					; 3 8
					; 4 1
					; 5 2 -	One/Two	player
					; 6 4
					; 7 8
		ld	a, (g_Flags)	; 0 1
					; 1 2
					; 2 4
					; 3 8
					; 4 1 -	0 - joy, 1 - KeyboardUserInput
					; 5 2 -	0 one player,1 - 2 player
					; 6 4 -	Game Flag (no demo)?
					; 7 8 -	Activ Player?
		xor	20h ; ' '
		and	20h ; ' '
		ld	(hl), a
		ret
; End of function _set_active_player


; =============== S U B	R O U T	I N E =======================================


SetXCoords5:				; CODE XREF: ShowJumper+30 p
					; ShowFishPools+2F p ...
		ld	a, (hl)

L5FC5:					; CODE XREF: SetXCoords5+5 j
		ld	(de), a
		add	a, 20h ; ' '
		inc	de
		
		;djnz
		dec b
		jp nz,L5FC5

		ret
; End of function SetXCoords5




xGameMessages:	
		dw VLINE+(0*32)+12		; DATA XREF: DispalyMessages o
		db 'H','I','@'
		db 0FEh
		dw VLINE+(0*32)+22
		db 'S','T','A','G','E','@'
		db 0FEh
		dw VLINE+(1*32)+12
		db 'T','I','M','E',  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
		db 0FEh
		dw VLINE+(23*32)+22
		db 'S','C','E','N','E','@'
		db 0FEh

;warning !
;x1P used in xGameMessages, move carrefully
;

x1P:
		dw 		VLINE+(0*32)+2		; DATA XREF: ShowPlayerID+B o
		db 		'1','P','@'
		db 		0FFh

x2P:
		dw 		VLINE+(1*32)+2		; DATA XREF: DispalyMessages+D o
		db 		'2','P','@'
		db 		0FFh

xGameOver:	dw VLINE+(11*32)+11		; DATA XREF: RAM:4304 o
		db 'G','A','M','E',  0,  0,'O','V','E','R'
		db 0FEh

xGameOverPlayer:dw VLINE+(9*32)+12		; DATA XREF: ML_9_BeforeStage:loc_427F o
		db 'P','L','A','Y','E','R'
		db 0FFh

xBonus:		dw VLINE+(12*32)+8		; DATA XREF: ML_9_BeforeStage+34 o
		db 'B','O','N','U','S',  0,'S','C','O','R','E',  0,'2','0','0','0'
		db 0FFh

