
SelectGameFont:
		call	cls_aczu
		call 	font_prepare_game
		call	SET_GAME_LUT

		ret		

SelectMenuFont:
;ESL_DEBUG
		call 	cls_aczu
		call 	font_prepare_title
                call    SET_MENU_LUT
;ESL_DEBUG
		ret
SET_GAME_LUT:
		ld	hl, regbase1C+LUT
;
;  При записи в LUT биты 
;D0...D3 задают номер одной из 16; строк таблицы, а 
;D4...D7 - содержимое этой строки.

; D7 - задает интенсивность (яркость),
; D6 - наличие красного цвета, 
; D5 - зеленого цвета, 
; D4 - синего цвета.
; D3 - соответствует АЦЗУ, 
; D2 - слою ГЗУ #2, 
; D1 - слою ГЗУ #1,
; D0 - слою ГЗУ #0;  

;colors
;  00 - black
;  01 - green
;  10 - red
;  11 - yellow
;1 00 -  
;1 01 - blue    
;1 10 -     
;1 11 -     
;
;1    - aczu
;  
;esl colors
;                             xrgbC210
		ld	(hl), 00000000b		;black
		ld	(hl), 00100001b 	;green
		ld	(hl), 01000010b 	;red
		ld	(hl), 01100011b 	;yellow

		ld	(hl), 00001000b		;aczu on black - white
		ld	(hl), 10011001b 	;blue
		ld	(hl), 01001010b
		ld	(hl), 01101011b

;white all with plane3
		ld	(hl), 10110100b
		ld	(hl), 10110101b
		ld	(hl), 10110110b
		ld	(hl), 10110111b
		ld	(hl), 10111100b
		ld	(hl), 10111101b
		ld	(hl), 10111110b
		ld	(hl), 10111111b

		ret

SET_MENU_LUT:
;title
;0 00 черный
;0 01 серый
;0 10 светло зеленый
;0 11 белый

;1 11 голубой
;1 10 зеленый

                ld      hl, regbase1C+LUT

;                             xrgbC210
                ld      (hl), 00000000b         ;black
                ld      (hl), 01110001b         ;gray
                ld      (hl), 10100010b         ;light green
                ld      (hl), 11110011b         ;white

                ld      (hl), 00101010b         ;aczu on light green - green
                ld      (hl), 10111011b         ;cyan
                ret

;hl	addr
;b - rows
;c - row len
;a - value

FILL_ACZU_BLOCK:
		push	hl
		pop	de
		inc	de
		ld 	(acx5+1),a
acx4:
	        push	bc
		push	hl
		push	de
	        ;ld      bc,32-1;64*4-1
	        ld 	b,0
acx5:	        
	        ld      a,0bfh
	        ld      (hl),a
	        call    _LDIR_

	        ld 	bc,64
	        pop	hl
	        add 	hl,bc
	        ex 	de,hl
	        pop	hl
	        add 	hl,bc

	        pop	bc
	        dec 	b
	        jp	nz,acx4
	        ret

actual_snd_picture:
		db 	1

update_snd_picture:
		ld 	a,(actual_snd_picture)
		ld 	b,a
		ld 	a,(no_sound_flag)
		cp 	b
		ret 	z


		ld 	(actual_snd_picture),a
		push 	hl
		push 	de

		ld 	de,spr_snd_on

		or  	a
		jp	z,x_snd
		ld 	de,spr_snd_off
x_snd:

		ld	a, 6Ch ; 'l'
		ld	(regbase1C+SYSREG), a




		ld	a, _u0|_COLOR_MODE
		ld	(regbase6C+NCREG), a

  		ld 	hl,GZU_BASE+(192+10+10)*64+30

	        ld      bc, 64-1
	        ld      a,0ffh

	        dup     11
	                ld      (hl),a
	                inc     l
	                ld      (hl),a
	                add     hl,bc
	        edup

		ld	a, _u3|_COLOR_MODE
		ld	(regbase6C+NCREG), a

;GZU_BASE        EQU     GZU+(GR_Y*64*16)+GR_X;+(256-192)/2*64+(64-32)/2

  		ld 	hl,GZU_BASE+(192+10+10)*64+30

	        ld      bc, 64-1

	        dup     11
	        	ld 	a,(de)
	                ld      (hl),a
	                inc 	de
	                inc     l
	        	ld 	a,(de)
	                ld      (hl),a
	                inc 	de
	                add     hl,bc
	        edup

		ld	a, 1Ch
		ld	(regbase6C+SYSREG), a
		pop	de
		pop	hl
		ret


spr_snd_on:
;2 x 11
	db	00000011b,00010000b
	db	00000111b,00001000b
	db	00001111b,00100100b
	db	01111111b,00010010b
	db	01111111b,01001010b
	db	01111111b,00101010b
	db	01111111b,01001010b
	db	01111111b,00010010b
	db	00001111b,00100100b
	db	00000111b,00001000b
	db	00000011b,00010000b
spr_snd_off:
;2 x 11
	db	01000000b,11010000b
	db	00100001b,10100000b
	db	00010011b,01000000b
	db	00001010b,10000000b
	db	00010101b,01000000b
	db	00011010b,11000000b
	db	00010101b,01000000b
	db	00001010b,10000000b
	db	00010011b,01000000b
	db	00100001b,10100000b
	db	01000000b,11010000b
